//
//  FollowersPresenter.swift
//  VKExt
//
//  Created Ярослав Стрельников on 31.07.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit

class FollowersPresenter: FollowersPresenterProtocol {

    weak private var view: FollowersViewProtocol?
    var interactor: FollowersInteractorProtocol?
    private let router: FollowersWireframeProtocol

    init(interface: FollowersViewProtocol, interactor: FollowersInteractorProtocol?, router: FollowersWireframeProtocol) {
        self.view = interface
        self.interactor = interactor
        self.router = router
    }

    func start(request: FriendModel.Request.RequestType) {
        guard let interactor = self.interactor else { return }
        interactor.start(request: request)
    }
    
    func presentData(response: FriendModel.Response.ResponseType) {
        switch response {
        case .presentFriend(response: let response):
            let cells = response.items?.compactMap { (item) in
                friendCellViewModel(from: item)
            }
            
            let friendViewModel = FriendViewModel.init(cell: cells ?? [], footerTitle: "")
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayFriend(friendViewModel: friendViewModel))
            }
        case .presentFooterLoader:
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayFooterLoader)
            }
        case .presentFooterError(message: let messageError):
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayFooterError(message: messageError))
            }
        }
    }
    
    private func friendCellViewModel(from friend: FriendItem) -> FriendViewModel.Cell {
        let friendCellViewModel = FriendViewModel.Cell.init(id: friend.id, firstName: friend.firstName, lastName: friend.lastName, isClosed: friend.isClosed, isOnline: friend.onlineInfo?.isOnline, isMobile: friend.onlineInfo?.isMobile, photo100: friend.photo100, school: friend.schools?[0].name, homeTown: friend.homeTown)
        return friendCellViewModel
    }
}
